import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  DescribePackageVersionRequest,
  DescribePackageVersionResult,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribePackageVersionCommandInput
  extends DescribePackageVersionRequest {}
export interface DescribePackageVersionCommandOutput
  extends DescribePackageVersionResult,
    __MetadataBearer {}
export declare class DescribePackageVersionCommand extends $Command<
  DescribePackageVersionCommandInput,
  DescribePackageVersionCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: DescribePackageVersionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribePackageVersionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribePackageVersionCommandInput,
    DescribePackageVersionCommandOutput
  >;
  private serialize;
  private deserialize;
}
