import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  ListPackageVersionDependenciesRequest,
  ListPackageVersionDependenciesResult,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListPackageVersionDependenciesCommandInput
  extends ListPackageVersionDependenciesRequest {}
export interface ListPackageVersionDependenciesCommandOutput
  extends ListPackageVersionDependenciesResult,
    __MetadataBearer {}
export declare class ListPackageVersionDependenciesCommand extends $Command<
  ListPackageVersionDependenciesCommandInput,
  ListPackageVersionDependenciesCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: ListPackageVersionDependenciesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListPackageVersionDependenciesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListPackageVersionDependenciesCommandInput,
    ListPackageVersionDependenciesCommandOutput
  >;
  private serialize;
  private deserialize;
}
